Package org.apache.uima

# Interface ResourceSpecifierFactory

All Known Implementing Classes:
  `ResourceSpecifierFactory_impl`

public interface ResourceSpecifierFactory
A factory used to create `ResourceSpecifier` instances and instances of other objects needed to compose `ResourceSpecifier`s.

The primary method on this class is `createObject(Class)`. Given the `Class` of a UIMA interface related to Resource Specifiers, this method will construct an instance that implements that interface. Other methods are provided as a convenience for creating specific types of objects.

A UIMA developer who implements a new type of Resource Specifier must register their implementation with this factory using the `addMapping(String, String)` method.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addMapping(String aInterfaceName, String aClassName)`
  Adds a mapping from interface class to implementation class.
  `AllowedValue`
  `createAllowedValue()`
  Creates an `AllowedValue`.
  `AnalysisEngineDescription`
  `createAnalysisEngineDescription()`
  Creates a `AnalysisEngineDescription`.
  `AnalysisEngineMetaData`
  `createAnalysisEngineMetaData()`
  Creates a `AnalysisEngineMetaData`.
  `CasProcessorExecArg`
  `createArg()`
  `Capability`
  `createCapability()`
  Creates a `Capability`.
  `CapabilityLanguageFlow`
  `createCapabilityLanguageFlow()`
  Creates a `CapabilityLanguageFlow`.
  `CasConsumerDescription`
  `createCasConsumerDescription()`
  Creates a `CasConsumerDescription`.
  `CpeCollectionReaderCasInitializer`
  `createCasInitializer()`
  `CpeCasProcessors`
  `createCasProcessors()`
  `CpeCheckpoint`
  `createCheckpoint()`
  `CpeCollectionReaderIterator`
  `createCollectionIterator()`
  `CpeCollectionReader`
  `createCollectionReader()`
  `CollectionReaderDescription`
  `createCollectionReaderDescription()`
  Creates a `CollectionReaderDescription`.
  `ConfigurationGroup`
  `createConfigurationGroup()`
  Creates a `ConfigurationGroup`.
  `ConfigurationParameter`
  `createConfigurationParameter()`
  Creates a `ConfigurationParameter`.
  `ConfigurationParameterDeclarations`
  `createConfigurationParameterDeclarations()`
  Creates a `ConfigurationParameterDeclarations`.
  `ConfigurationParameterSettings`
  `createConfigurationParameterSettings()`
  Creates a `ConfigurationParameterSettings`.
  `CpeConfiguration`
  `createCpeConfig()`
  `CpeDescription`
  `createCpeDescription()`
  `CustomResourceSpecifier`
  `createCustomResourceSpecifier()`
  Creates a `CustomResourceSpecifier`.
  `CasProcessorDeploymentParams`
  `createDeploymentParameters()`
  `CpeComponentDescriptor`
  `createDescriptor()`
  `CasProcessorRuntimeEnvParam`
  `createEnv()`
  `CasProcessorErrorHandling`
  `createErrorHandling()`
  `CasProcessorExecutable`
  `createExec()`
  `ExternalResourceBinding`
  `createExternalResourceBinding()`
  Creates an `ExternalResourceBinding`.
  `ExternalResourceDependency`
  `createExternalResourceDependency()`
  Creates an `ExternalResourceDependency`.
  `ExternalResourceDescription`
  `createExternalResourceDescription()`
  Creates an `ExternalResourceDescription`.
  `FeatureDescription`
  `createFeatureDescription()`
  Creates a `FeatureDescription`.
  `FileLanguageResourceSpecifier`
  `createFileLanguageResourceSpecifier()`
  Creates a `FileLanguageResourceSpecifier`.
  `FileResourceSpecifier`
  `createFileResourceSpecifier()`
  Creates a `FileResourceSpecifier`.
  `FixedFlow`
  `createFixedFlow()`
  Creates a `FixedFlow`.
  `FlowControllerDeclaration`
  `createFlowControllerDeclaration()`
  Creates a `FlowControllerDeclaration`
  `FlowControllerDescription`
  `createFlowControllerDescription()`
  Creates a `FlowControllerDescription`
  `FsIndexCollection`
  `createFsIndexCollection()`
  Creates an `FsIndexCollection`.
  `FsIndexDescription`
  `createFsIndexDescription()`
  Creates an `FsIndexDescription`.
  `FsIndexKeyDescription`
  `createFsIndexKeyDescription()`
  Creates an `FsIndexKeyDescription`.
  `Import`
  `createImport()`
  Creates an `Import`
  `CpeInclude`
  `createInclude()`
  `JMSMessagingSpecifier`
  `createJMSMessagingSpecifier()`
  Creates a `JMSMessagingSpecifier`.
  `MailMessagingSpecifier`
  `createMailMessagingSpecifier()`
  Creates a `MailMessagingSpecifier`.
  `MQMessagingSpecifier`
  `createMQMessagingSpecifier()`
  Creates a `MQMessagingSpecifier`.
  `NameValuePair`
  `createNameValuePair()`
  Creates a `NameValuePair`.
  `Object`
  `createObject(Class aInterface)`
  Creates an object that implements the given interface.
  `OperationalProperties`
  `createOperationalProperties()`
  Creates an `OperationalProperties`
  `OutputQueue`
  `createOutputQueue()`
  `Parameter`
  `createParameter()`
  Creates a `Parameter`
  `PearSpecifier`
  `createPearSpecifier()`
  Creates a `PearSpecifier`.
  `ProcessingResourceMetaData`
  `createProcessingResourceMetaData()`
  Creates a `ProcessingResourceMetaData`.
  `ResourceManagerConfiguration`
  `createResourceManagerConfiguration()`
  Creates an `ResourceManagerConfiguration`.
  `ResourceMetaData`
  `createResourceMetaData()`
  Creates a `ResourceMetaData`.
  `ResultSpecification`
  `createResultSpecification()`
  Creates a `ResultSpecification`.
  `CasProcessorRunInSeperateProcess`
  `createRunInSeperateProcess()`
  `Settings`
  `createSettings()`
  Creates an empty `Settings` for External Override parameters.
  `SimplePrecondition`
  `createSimplePrecondition()`
  Creates a `SimplePrecondition`.
  `SofaMapping`
  `createSofaMapping()`
  Creates a `SofaMapping`.
  `TaeDescription`
  `createTaeDescription()`
  Deprecated.
  As of v2.0, `createAnalysisEngineDescription()` should be used instead.
  `TypeDescription`
  `createTypeDescription()`
  Creates a `TypeDescription`.
  `TypeOrFeature`
  `createTypeOrFeature()`
  Creates a `TypeOrFeature`.
  `TypePriorities`
  `createTypePriorities()`
  Creates an `TypePriorities`.
  `TypePriorityList`
  `createTypePriorityList()`
  Creates an `TypePriorityList`.
  `TypeSystemDescription`
  `createTypeSystemDescription()`
  Creates a `TypeSystemDescription`.
  `URISpecifier`
  `createURISpecifier()`
  Creates a `URISpecifier`.

- ## Method Details

  - ### createObject

    Object createObject(Class aInterface)
    Creates an object that implements the given interface.
    Parameters:
      `aInterface` - the `Class` object representing the type of interface to be instantiated.
    Returns:
      an `Object` that implements `aInterface`. Returns `null` if no object that implements `aInterface` is known to this factory.

  - ### addMapping

    void addMapping(String aInterfaceName, String aClassName) throws ClassNotFoundException
    Adds a mapping from interface class to implementation class. Applications do not typically need to use this method. UIMA developers who implement new types of `ResourceSpecifier`, however, must register their implementations using this method so that this factory knows how to construct instances of those implementation classes.
    Parameters:
      `aInterfaceName` - the fully-qualified name of a UIMA interface
      `aClassName` - the fully-qualified name of a class that implements `aInterfaceName`.
    Throws:
      `ClassNotFoundException` - if either of the classes named by `aInterfaceName` or `aClassName` were not found.

  - ### createURISpecifier

    URISpecifier createURISpecifier()
    Creates a `URISpecifier`.
    Returns:
      an instance of an object implementing `URISpecifier`.

  - ### createMQMessagingSpecifier

    MQMessagingSpecifier createMQMessagingSpecifier()
    Creates a `MQMessagingSpecifier`.
    Returns:
      an instance of an object implementing `MQMessagingSpecifier`.

  - ### createJMSMessagingSpecifier

    JMSMessagingSpecifier createJMSMessagingSpecifier()
    Creates a `JMSMessagingSpecifier`.
    Returns:
      an instance of an object implementing `JMSMessagingSpecifier`.

  - ### createMailMessagingSpecifier

    MailMessagingSpecifier createMailMessagingSpecifier()
    Creates a `MailMessagingSpecifier`.
    Returns:
      an instance of an object implementing `MailMessagingSpecifier`.

  - ### createFileResourceSpecifier

    FileResourceSpecifier createFileResourceSpecifier()
    Creates a `FileResourceSpecifier`.
    Returns:
      an instance of an object implementing `FileResourceSpecifier`.

  - ### createFileLanguageResourceSpecifier

    FileLanguageResourceSpecifier createFileLanguageResourceSpecifier()
    Creates a `FileLanguageResourceSpecifier`.
    Returns:
      an instance of an object implementing `FileLanguageResourceSpecifier`.

  - ### createAnalysisEngineDescription

    AnalysisEngineDescription createAnalysisEngineDescription()
    Creates a `AnalysisEngineDescription`.
    Returns:
      an instance of an object implementing `AnalysisEngineDescription`.

  - ### createTaeDescription

    @Deprecated TaeDescription createTaeDescription()
    Deprecated.
    As of v2.0, `createAnalysisEngineDescription()` should be used instead.
    Creates a `AnalysisEngineDescription`.
    Returns:
      an instance of an object implementing `AnalysisEngineDescription`.

  - ### createResourceMetaData

    ResourceMetaData createResourceMetaData()
    Creates a `ResourceMetaData`.
    Returns:
      an instance of an object implementing `ResourceMetaData`.

  - ### createProcessingResourceMetaData

    ProcessingResourceMetaData createProcessingResourceMetaData()
    Creates a `ProcessingResourceMetaData`.
    Returns:
      an instance of an object implementing `ProcessingResourceMetaData`.

  - ### createAnalysisEngineMetaData

    AnalysisEngineMetaData createAnalysisEngineMetaData()
    Creates a `AnalysisEngineMetaData`.
    Returns:
      an instance of an object implementing `AnalysisEngineMetaData`.

  - ### createConfigurationParameterDeclarations

    ConfigurationParameterDeclarations createConfigurationParameterDeclarations()
    Creates a `ConfigurationParameterDeclarations`.
    Returns:
      an instance of an object implementing `ConfigurationParameterDeclarations`.

  - ### createConfigurationParameter

    ConfigurationParameter createConfigurationParameter()
    Creates a `ConfigurationParameter`.
    Returns:
      an instance of an object implementing `ConfigurationParameter`.

  - ### createConfigurationGroup

    ConfigurationGroup createConfigurationGroup()
    Creates a `ConfigurationGroup`.
    Returns:
      an instance of an object implementing `ConfigurationGroup`.

  - ### createConfigurationParameterSettings

    ConfigurationParameterSettings createConfigurationParameterSettings()
    Creates a `ConfigurationParameterSettings`.
    Returns:
      an instance of an object implementing `ConfigurationParameterSettings`.

  - ### createSettings

    Settings createSettings()
    Creates an empty `Settings` for External Override parameters.
    Returns:
      an instance of an object implementing `Settings`.

  - ### createCapability

    Capability createCapability()
    Creates a `Capability`.
    Returns:
      an instance of an object implementing `Capability`.

  - ### createSimplePrecondition

    SimplePrecondition createSimplePrecondition()
    Creates a `SimplePrecondition`.
    Returns:
      an instance of an object implementing `SimplePrecondition`.

  - ### createTypeSystemDescription

    TypeSystemDescription createTypeSystemDescription()
    Creates a `TypeSystemDescription`.
    Returns:
      an instance of an object implementing `TypeSystemDescription`.

  - ### createTypeDescription

    TypeDescription createTypeDescription()
    Creates a `TypeDescription`.
    Returns:
      an instance of an object implementing `TypeDescription`.

  - ### createFeatureDescription

    FeatureDescription createFeatureDescription()
    Creates a `FeatureDescription`.
    Returns:
      an instance of an object implementing `FeatureDescription`.

  - ### createFsIndexCollection

    FsIndexCollection createFsIndexCollection()
    Creates an `FsIndexCollection`.
    Returns:
      an instance of an object implementing `FsIndexCollection`.

  - ### createFsIndexDescription

    FsIndexDescription createFsIndexDescription()
    Creates an `FsIndexDescription`.
    Returns:
      an instance of an object implementing `FsIndexDescription`.

  - ### createFsIndexKeyDescription

    FsIndexKeyDescription createFsIndexKeyDescription()
    Creates an `FsIndexKeyDescription`.
    Returns:
      an instance of an object implementing `FsIndexKeyDescription`.

  - ### createFixedFlow

    FixedFlow createFixedFlow()
    Creates a `FixedFlow`.
    Returns:
      an instance of an object implementing `FixedFlow`.

  - ### createCapabilityLanguageFlow

    CapabilityLanguageFlow createCapabilityLanguageFlow()
    Creates a `CapabilityLanguageFlow`.
    Returns:
      an instance of an object implementing `CapabilityLanguageFlow`.

  - ### createNameValuePair

    NameValuePair createNameValuePair()
    Creates a `NameValuePair`.
    Returns:
      an instance of an object implementing `NameValuePair`.

  - ### createTypeOrFeature

    TypeOrFeature createTypeOrFeature()
    Creates a `TypeOrFeature`.
    Returns:
      an instance of an object implementing `TypeOrFeature`.

  - ### createAllowedValue

    AllowedValue createAllowedValue()
    Creates an `AllowedValue`.
    Returns:
      an instance of an object implementing `AllowedValue`.

  - ### createTypePriorities

    TypePriorities createTypePriorities()
    Creates an `TypePriorities`.
    Returns:
      an instance of an object implementing `TypePriorities`.

  - ### createTypePriorityList

    TypePriorityList createTypePriorityList()
    Creates an `TypePriorityList`.
    Returns:
      an instance of an object implementing `TypePriorityList`.

  - ### createExternalResourceDependency

    ExternalResourceDependency createExternalResourceDependency()
    Creates an `ExternalResourceDependency`.
    Returns:
      an instance of an object implementing `ExternalResourceDependency`.

  - ### createResourceManagerConfiguration

    ResourceManagerConfiguration createResourceManagerConfiguration()
    Creates an `ResourceManagerConfiguration`.
    Returns:
      an instance of an object implementing `ResourceManagerConfiguration`.

  - ### createExternalResourceBinding

    ExternalResourceBinding createExternalResourceBinding()
    Creates an `ExternalResourceBinding`.
    Returns:
      an instance of an object implementing `ExternalResourceBinding`.

  - ### createExternalResourceDescription

    ExternalResourceDescription createExternalResourceDescription()
    Creates an `ExternalResourceDescription`.
    Returns:
      an instance of an object implementing `ExternalResourceDescription`.

  - ### createCasConsumerDescription

    CasConsumerDescription createCasConsumerDescription()
    Creates a `CasConsumerDescription`.
    Returns:
      an instance of an object implementing `CasConsumerDescription`.

  - ### createCollectionReaderDescription

    CollectionReaderDescription createCollectionReaderDescription()
    Creates a `CollectionReaderDescription`.
    Returns:
      an instance of an object implementing `CollectionReaderDescription`.

  - ### createResultSpecification

    ResultSpecification createResultSpecification()
    Creates a `ResultSpecification`.
    Returns:
      an instance of an object implementing `ResultSpecification`.

  - ### createSofaMapping

    SofaMapping createSofaMapping()
    Creates a `SofaMapping`.
    Returns:
      an instance of an object implementing `SofaMapping`.

  - ### createImport

    Import createImport()
    Creates an `Import`
    Returns:
      an instance of an object implementing `Import`.

  - ### createOperationalProperties

    OperationalProperties createOperationalProperties()
    Creates an `OperationalProperties`
    Returns:
      an instance of an object implementing `OperationalProperties`.

  - ### createParameter

    Parameter createParameter()
    Creates a `Parameter`
    Returns:
      an instance of an object implementing `Parameter`.

  - ### createFlowControllerDeclaration

    FlowControllerDeclaration createFlowControllerDeclaration()
    Creates a `FlowControllerDeclaration`
    Returns:
      an instance of an object implementing `FlowControllerDeclaration`.

  - ### createCustomResourceSpecifier

    CustomResourceSpecifier createCustomResourceSpecifier()
    Creates a `CustomResourceSpecifier`.
    Returns:
      an instance of an object implementing `CustomResourceSpecifier`.

  - ### createPearSpecifier

    PearSpecifier createPearSpecifier()
    Creates a `PearSpecifier`.
    Returns:
      an instance of an object implementing `PearSpecifier`.

  - ### createFlowControllerDescription

    FlowControllerDescription createFlowControllerDescription()
    Creates a `FlowControllerDescription`
    Returns:
      an instance of an object implementing `FlowControllerDescription`.

  - ### createCasInitializer

    CpeCollectionReaderCasInitializer createCasInitializer()

  - ### createCasProcessors

    CpeCasProcessors createCasProcessors()

  - ### createCheckpoint

    CpeCheckpoint createCheckpoint()

  - ### createCollectionIterator

    CpeCollectionReaderIterator createCollectionIterator()

  - ### createCollectionReader

    CpeCollectionReader createCollectionReader()

  - ### createCpeConfig

    CpeConfiguration createCpeConfig()

  - ### createCpeDescription

    CpeDescription createCpeDescription()

  - ### createDescriptor

    CpeComponentDescriptor createDescriptor()

  - ### createErrorHandling

    CasProcessorErrorHandling createErrorHandling()

  - ### createInclude

    CpeInclude createInclude()

  - ### createRunInSeperateProcess

    CasProcessorRunInSeperateProcess createRunInSeperateProcess()

  - ### createDeploymentParameters

    CasProcessorDeploymentParams createDeploymentParameters()

  - ### createExec

    CasProcessorExecutable createExec()

  - ### createArg

    CasProcessorExecArg createArg()

  - ### createOutputQueue

    OutputQueue createOutputQueue()

  - ### createEnv

    CasProcessorRuntimeEnvParam createEnv()